
<!DOCTYPE html>


<html lang="en" data-content_root="../../" >

  <head>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" /><meta name="viewport" content="width=device-width, initial-scale=1" />

    <title>Computational graph &#8212; Eclipse Aidge  documentation</title>
  
  
  
  <script data-cfasync="false">
    document.documentElement.dataset.mode = localStorage.getItem("mode") || "";
    document.documentElement.dataset.theme = localStorage.getItem("theme") || "";
  </script>
  <!--
    this give us a css class that will be invisible only if js is disabled
  -->
  <noscript>
    <style>
      .pst-js-only { display: none !important; }

    </style>
  </noscript>
  
  <!-- Loaded before other Sphinx assets -->
  <link href="../../_static/styles/theme.css?digest=8878045cc6db502f8baf" rel="stylesheet" />
<link href="../../_static/styles/pydata-sphinx-theme.css?digest=8878045cc6db502f8baf" rel="stylesheet" />

    <link rel="stylesheet" type="text/css" href="../../_static/pygments.css?v=8f2a1f02" />
    <link rel="stylesheet" type="text/css" href="../../_static/graphviz.css?v=4ae1632d" />
    <link rel="stylesheet" type="text/css" href="../../_static/copybutton.css?v=76b2166b" />
    <link rel="stylesheet" type="text/css" href="../../_static/sg_gallery.css?v=d2d258e8" />
    <link rel="stylesheet" type="text/css" href="../../_static/sphinx-design.min.css?v=95c83b7e" />
    <link rel="stylesheet" type="text/css" href="../../_static/css/custom.css?v=794b2ffd" />
  
  <!-- So that users can add custom icons -->
  <script src="../../_static/scripts/fontawesome.js?digest=8878045cc6db502f8baf"></script>
  <!-- Pre-loaded scripts that we'll load fully later -->
  <link rel="preload" as="script" href="../../_static/scripts/bootstrap.js?digest=8878045cc6db502f8baf" />
<link rel="preload" as="script" href="../../_static/scripts/pydata-sphinx-theme.js?digest=8878045cc6db502f8baf" />

    <script src="../../_static/documentation_options.js?v=5929fcd5"></script>
    <script src="../../_static/doctools.js?v=9bcbadda"></script>
    <script src="../../_static/sphinx_highlight.js?v=dc90522c"></script>
    <script src="../../_static/clipboard.min.js?v=a7894cd8"></script>
    <script src="../../_static/copybutton.js?v=f281be69"></script>
    <script src="../../_static/design-tabs.js?v=f930bc37"></script>
    <script src="https://cdn.jsdelivr.net/npm/@jupyter-widgets/html-manager@^1.0.1/dist/embed-amd.js"></script>
    <script>DOCUMENTATION_OPTIONS.pagename = 'source/UserGuide/modelGraph';</script>
    <script>
        DOCUMENTATION_OPTIONS.theme_version = '0.16.1';
        DOCUMENTATION_OPTIONS.theme_switcher_json_url = 'https://eclipse-aidge.readthedocs.io/en/dev/_static/version_switcher.json';
        DOCUMENTATION_OPTIONS.theme_switcher_version_match = '0.5.0';
        DOCUMENTATION_OPTIONS.show_version_warning_banner =
            false;
        </script>
    <script src="../../_static/js/mermaid.min.js"></script>
    <link rel="index" title="Index" href="../../genindex.html" />
    <link rel="search" title="Search" href="../../search.html" />
    <link rel="next" title="Load and store model" href="loadStoreModel.html" />
    <link rel="prev" title="Data" href="data.html" />
  <meta name="viewport" content="width=device-width, initial-scale=1"/>
  <meta name="docsearch:language" content="en"/>
  <meta name="docsearch:version" content="0.5.0" />
  </head>
  
  
  <body data-bs-spy="scroll" data-bs-target=".bd-toc-nav" data-offset="180" data-bs-root-margin="0px 0px -60%" data-default-mode="">

  
  
  <div id="pst-skip-link" class="skip-link d-print-none"><a href="#main-content">Skip to main content</a></div>
  
  <div id="pst-scroll-pixel-helper"></div>
  
  <button type="button" class="btn rounded-pill" id="pst-back-to-top">
    <i class="fa-solid fa-arrow-up"></i>Back to top</button>

  
  <dialog id="pst-search-dialog">
    
<form class="bd-search d-flex align-items-center"
      action="../../search.html"
      method="get">
  <i class="fa-solid fa-magnifying-glass"></i>
  <input type="search"
         class="form-control"
         name="q"
         placeholder="Search the docs ..."
         aria-label="Search the docs ..."
         autocomplete="off"
         autocorrect="off"
         autocapitalize="off"
         spellcheck="false"/>
  <span class="search-button__kbd-shortcut"><kbd class="kbd-shortcut__modifier">Ctrl</kbd>+<kbd>K</kbd></span>
</form>
  </dialog>

  <div class="pst-async-banner-revealer d-none">
  <aside id="bd-header-version-warning" class="d-none d-print-none" aria-label="Version warning"></aside>
</div>

  
    <header class="bd-header navbar navbar-expand-lg bd-navbar d-print-none">
<div class="bd-header__inner bd-page-width">
  <button class="pst-navbar-icon sidebar-toggle primary-toggle" aria-label="Site navigation">
    <span class="fa-solid fa-bars"></span>
  </button>
  
  
  <div class="col-lg-3 navbar-header-items__start">
    
      <div class="navbar-item">

  
    
  

<a class="navbar-brand logo" href="../../index.html">
  
  
  
  
  
    
    
      
    
    
    <img src="../../_static/Isotype-aidge.png" class="logo__image only-light" alt=""/>
    <img src="../../_static/Isotype-aidge.png" class="logo__image only-dark pst-js-only" alt=""/>
  
  
    <p class="title logo__title">Eclipse Aidge</p>
  
</a></div>
    
      <div class="navbar-item">
<div class="version-switcher__container dropdown pst-js-only">
  <button id="pst-version-switcher-button-2"
    type="button"
    class="version-switcher__button btn btn-sm dropdown-toggle"
    data-bs-toggle="dropdown"
    aria-haspopup="listbox"
    aria-controls="pst-version-switcher-list-2"
    aria-label="Version switcher list"
  >
    Choose version  <!-- this text may get changed later by javascript -->
    <span class="caret"></span>
  </button>
  <div id="pst-version-switcher-list-2"
    class="version-switcher__menu dropdown-menu list-group-flush py-0"
    role="listbox" aria-labelledby="pst-version-switcher-button-2">
    <!-- dropdown will be populated by javascript on page load -->
  </div>
</div></div>
    
  </div>
  
  <div class="col-lg-9 navbar-header-items">
    
    <div class="me-auto navbar-header-items__center">
      
        <div class="navbar-item">
<nav>
  <ul class="bd-navbar-elements navbar-nav">
    
<li class="nav-item ">
  <a class="nav-link nav-internal" href="../GetStarted/index.html">
    Get Started
  </a>
</li>


<li class="nav-item current active">
  <a class="nav-link nav-internal" href="index.html">
    User Guide
  </a>
</li>


<li class="nav-item ">
  <a class="nav-link nav-internal" href="../Tutorial/index.html">
    Tutorials
  </a>
</li>


<li class="nav-item ">
  <a class="nav-link nav-internal" href="../API/index.html">
    API
  </a>
</li>

  </ul>
</nav></div>
      
    </div>
    
    
    <div class="navbar-header-items__end">
      
        <div class="navbar-item navbar-persistent--container">
          

<button class="btn search-button-field search-button__button pst-js-only" title="Search" aria-label="Search" data-bs-placement="bottom" data-bs-toggle="tooltip">
 <i class="fa-solid fa-magnifying-glass"></i>
 <span class="search-button__default-text">Search</span>
 <span class="search-button__kbd-shortcut"><kbd class="kbd-shortcut__modifier">Ctrl</kbd>+<kbd class="kbd-shortcut__modifier">K</kbd></span>
</button>
        </div>
      
      
        <div class="navbar-item">

<button class="btn btn-sm nav-link pst-navbar-icon theme-switch-button pst-js-only" aria-label="Color mode" data-bs-title="Color mode"  data-bs-placement="bottom" data-bs-toggle="tooltip">
  <i class="theme-switch fa-solid fa-sun                fa-lg" data-mode="light" title="Light"></i>
  <i class="theme-switch fa-solid fa-moon               fa-lg" data-mode="dark"  title="Dark"></i>
  <i class="theme-switch fa-solid fa-circle-half-stroke fa-lg" data-mode="auto"  title="System Settings"></i>
</button></div>
      
        <div class="navbar-item"><ul class="navbar-icon-links"
    aria-label="Icon Links">
        <li class="nav-item">
          
          
          
          
          
          
          
          
          <a href="<https://gitlab.eclipse.org/eclipse/aidge>" title="GitLab" class="nav-link pst-navbar-icon" rel="noopener" target="_blank" data-bs-toggle="tooltip" data-bs-placement="bottom"><i class="fab fa-gitlab fa-lg" aria-hidden="true"></i>
            <span class="sr-only">GitLab</span></a>
        </li>
</ul></div>
      
    </div>
    
  </div>
  
  
    <div class="navbar-persistent--mobile">

<button class="btn search-button-field search-button__button pst-js-only" title="Search" aria-label="Search" data-bs-placement="bottom" data-bs-toggle="tooltip">
 <i class="fa-solid fa-magnifying-glass"></i>
 <span class="search-button__default-text">Search</span>
 <span class="search-button__kbd-shortcut"><kbd class="kbd-shortcut__modifier">Ctrl</kbd>+<kbd class="kbd-shortcut__modifier">K</kbd></span>
</button>
    </div>
  

  
    <button class="pst-navbar-icon sidebar-toggle secondary-toggle" aria-label="On this page">
      <span class="fa-solid fa-outdent"></span>
    </button>
  
</div>

    </header>
  

  <div class="bd-container">
    <div class="bd-container__inner bd-page-width">
      
      
      
      <dialog id="pst-primary-sidebar-modal"></dialog>
      <div id="pst-primary-sidebar" class="bd-sidebar-primary bd-sidebar">
        

  
  <div class="sidebar-header-items sidebar-primary__section">
    
    
      <div class="sidebar-header-items__center">
        
          
          
            <div class="navbar-item">
<nav>
  <ul class="bd-navbar-elements navbar-nav">
    
<li class="nav-item ">
  <a class="nav-link nav-internal" href="../GetStarted/index.html">
    Get Started
  </a>
</li>


<li class="nav-item current active">
  <a class="nav-link nav-internal" href="index.html">
    User Guide
  </a>
</li>


<li class="nav-item ">
  <a class="nav-link nav-internal" href="../Tutorial/index.html">
    Tutorials
  </a>
</li>


<li class="nav-item ">
  <a class="nav-link nav-internal" href="../API/index.html">
    API
  </a>
</li>

  </ul>
</nav></div>
          
        
      </div>
    
    
    
      <div class="sidebar-header-items__end">
        
          <div class="navbar-item">

<button class="btn btn-sm nav-link pst-navbar-icon theme-switch-button pst-js-only" aria-label="Color mode" data-bs-title="Color mode"  data-bs-placement="bottom" data-bs-toggle="tooltip">
  <i class="theme-switch fa-solid fa-sun                fa-lg" data-mode="light" title="Light"></i>
  <i class="theme-switch fa-solid fa-moon               fa-lg" data-mode="dark"  title="Dark"></i>
  <i class="theme-switch fa-solid fa-circle-half-stroke fa-lg" data-mode="auto"  title="System Settings"></i>
</button></div>
        
          <div class="navbar-item"><ul class="navbar-icon-links"
    aria-label="Icon Links">
        <li class="nav-item">
          
          
          
          
          
          
          
          
          <a href="<https://gitlab.eclipse.org/eclipse/aidge>" title="GitLab" class="nav-link pst-navbar-icon" rel="noopener" target="_blank" data-bs-toggle="tooltip" data-bs-placement="bottom"><i class="fab fa-gitlab fa-lg" aria-hidden="true"></i>
            <span class="sr-only">GitLab</span></a>
        </li>
</ul></div>
        
      </div>
    
  </div>
  
    <div class="sidebar-primary-items__start sidebar-primary__section">
        <div class="sidebar-primary-item">
<nav class="bd-docs-nav bd-links"
     aria-label="Section Navigation">
  <p class="bd-links__title" role="heading" aria-level="1">Section Navigation</p>
  <div class="bd-toc-item navbar-nav"><ul class="current nav bd-sidenav">
<li class="toctree-l1"><a class="reference internal" href="architecture.html">Framework architecture</a></li>
<li class="toctree-l1"><a class="reference internal" href="data.html">Data</a></li>
<li class="toctree-l1 current active"><a class="current reference internal" href="#">Computational graph</a></li>
<li class="toctree-l1"><a class="reference internal" href="loadStoreModel.html">Load and store model</a></li>
<li class="toctree-l1"><a class="reference internal" href="interoperability.html">Plateform interoperability</a></li>
<li class="toctree-l1"><a class="reference internal" href="transformGraph.html">Transform graph</a></li>
<li class="toctree-l1"><a class="reference internal" href="staticAnalysis.html">Static analysis</a></li>
<li class="toctree-l1"><a class="reference internal" href="executeGraph.html">Runtime graph execution</a></li>
<li class="toctree-l1"><a class="reference internal" href="learnModel.html">Learn model</a></li>
<li class="toctree-l1"><a class="reference internal" href="benchmark.html">Benchmark neural network model</a></li>
<li class="toctree-l1"><a class="reference internal" href="ensureRobustness.html">Ensure robustness</a></li>
<li class="toctree-l1"><a class="reference internal" href="optimizeGraph.html">Optimize graph</a></li>
<li class="toctree-l1"><a class="reference internal" href="export.html">Perform an export</a></li>
<li class="toctree-l1"><a class="reference internal" href="learnEdge.html">Learn on edge</a></li>
</ul>
</div>
</nav></div>
    </div>
  
  
  <div class="sidebar-primary-items__end sidebar-primary__section">
      <div class="sidebar-primary-item">
<div id="ethical-ad-placement"
      class="flat"
      data-ea-publisher="readthedocs"
      data-ea-type="readthedocs-sidebar"
      data-ea-manual="true">
</div></div>
  </div>


      </div>
      
      <main id="main-content" class="bd-main" role="main">
        
        
          <div class="bd-content">
            <div class="bd-article-container">
              
              <div class="bd-header-article d-print-none">
<div class="header-article-items header-article__inner">
  
    <div class="header-article-items__start">
      
        <div class="header-article-item">

<nav aria-label="Breadcrumb" class="d-print-none">
  <ul class="bd-breadcrumbs">
    
    <li class="breadcrumb-item breadcrumb-home">
      <a href="../../index.html" class="nav-link" aria-label="Home">
        <i class="fa-solid fa-home"></i>
      </a>
    </li>
    
    <li class="breadcrumb-item"><a href="index.html" class="nav-link">User Guide</a></li>
    
    <li class="breadcrumb-item active" aria-current="page"><span class="ellipsis">Computational graph</span></li>
  </ul>
</nav>
</div>
      
    </div>
  
  
</div>
</div>
              
              
              
                
<div id="searchbox"></div>
                <article class="bd-article">
                  
  <section id="computational-graph">
<h1>Computational graph<a class="headerlink" href="#computational-graph" title="Link to this heading">#</a></h1>
<section id="introduction">
<h2>Introduction<a class="headerlink" href="#introduction" title="Link to this heading">#</a></h2>
<p>AIDGE represents DNN modesl using a directional graph called the <a class="reference internal" href="#introduction"><span class="std std-ref">computational graph</span></a>.
This <a class="reference internal" href="#introduction"><span class="std std-ref">computational graph</span></a> is a set of <a class="reference internal" href="#node"><span class="std std-ref">nodes</span></a> connected with directed edges.
Each <a class="reference internal" href="#node"><span class="std std-ref">node</span></a> is associated with a computational operation and each edge represents a Data flow, i.e. the inputs and outputs associated to an operation performed by a <a class="reference internal" href="#node"><span class="std std-ref">node</span></a>.</p>
<img alt="../../_images/ComputationalGraph.PNG" class="align-center" src="../../_images/ComputationalGraph.PNG" />
</section>
<section id="node">
<h2>Node<a class="headerlink" href="#node" title="Link to this heading">#</a></h2>
<p>Nodes are the core constitutive element of the <a class="reference internal" href="#introduction"><span class="std std-ref">computational graph</span></a> and store the topological information of computational graph that will be used by the Scheduler to define the data flow.
Each node keeps the local topological informations of its neighbours according to two categories:</p>
<ul class="simple">
<li><p>The nodes connected toward a given nodes are its <strong>Parents</strong>.</p></li>
<li><p>The nodes receiving a connection from a given node are its <strong>Children</strong>.</p></li>
</ul>
</section>
<section id="operator">
<h2>Operator<a class="headerlink" href="#operator" title="Link to this heading">#</a></h2>
<section id="definition">
<h3>Definition<a class="headerlink" href="#definition" title="Link to this heading">#</a></h3>
<p>An operator defines the computational operation associated to a <a class="reference internal" href="#node"><span class="std std-ref">node</span></a>. The operator is a datastructure, which is agnostic to the implementation of the operation. To enable this agnosticity, operator have a reference to an Implementation, this concept is described in the next section.
An operator takes as inputs:</p>
<ul class="simple">
<li><p>Zero or more Data given by the incoming Data flow of the node, called <strong>Data Inputs</strong>;</p></li>
<li><p>A set of <strong>Parameters</strong> (zero or more).</p></li>
</ul>
<p>An operator produces one or more Data as outputs, called Data Outputs.</p>
<p>An operator defines the following properties to perform the computation:</p>
<ul class="simple">
<li><p>A set of <strong>attributes</strong> (0 or more) where an attribute is a value which specifies the operation (for example, the stride size of a convolution);</p></li>
<li><p>The number of inputs and their dimensions, datatype and precision;</p></li>
<li><p>The number of outputs and their dimensions, datatype and precision;</p></li>
<li><p>A reference to a forward implementation, which is a function that compute the operation;</p></li>
<li><p>A reference to a backward implementation, which is a function that computes the gradient.</p></li>
</ul>
<p>An operator can be associated to several nodes, this is possible since nodes manage the data flow and not the operator which does not know where its data comes from.
This is particularly useful for saving memory in the case of inputs/parameters sharing.</p>
</section>
<section id="implementation-of-an-operator">
<h3>Implementation of an operator<a class="headerlink" href="#implementation-of-an-operator" title="Link to this heading">#</a></h3>
<p>As previously mentioned, an operator is agnostic of the implementation, and to select an implementation, a register system (similar to the one used in the case of <a class="reference internal" href="data.html#tensor"><span class="std std-ref">Tensor</span></a>) is available.
This selection depends on the following attributes:</p>
<ul class="simple">
<li><p>The Backend, defined by both the hardware target (e.g. CPU, GPU, …) and available libraries (e.g OpenCV);</p></li>
<li><p>The Datatype (float, int, …) and Precision (8bits, 16bits, 32bits,…) of the inputs and outputs;</p></li>
<li><p>The DataFormat (NCHW, NHWC, … see this <a class="reference external" href="https://oneapi-src.github.io/oneDNN/dev_guide_understanding_memory_formats.html">link</a> for more details)</p></li>
<li><p>The Kernel : the algorithm chosen to perform the computation, at the moment no specification exist on how to implement this.</p></li>
</ul>
<p>As long as these attributes are not defined, the forward and backward functions of the operator will remain empty.</p>
</section>
<section id="example-of-operator">
<h3>Example of Operator<a class="headerlink" href="#example-of-operator" title="Link to this heading">#</a></h3>
<p>Here is an example of operator for the Convolution:</p>
<img alt="../../_images/OperatorExample.PNG" src="../../_images/OperatorExample.PNG" />
</section>
</section>
<section id="graph-view">
<h2>Graph View<a class="headerlink" href="#graph-view" title="Link to this heading">#</a></h2>
<p>Since the topology of a <a class="reference internal" href="#introduction"><span class="std std-ref">computational graph</span></a> is entirely carried by the <a class="reference internal" href="#node"><span class="std std-ref">nodes</span></a> themselves, its implementation is called <strong>graph view</strong> in AIDGE.
More generally, a graph view allows the user to define a set of nodes to work with. Therefore a graph view can be used to model a whole DNN (a complete computational graph) or a part of it (a subgraph).
A graph view allows applying several modification to its set of nodes and their <a class="reference internal" href="#operator"><span class="std std-ref">operators</span></a> at once:</p>
<ul class="simple">
<li><p>Setting a common backend for each operator</p></li>
<li><p>Setting the precision of operators</p></li>
</ul>
<p>Nodes of a graph view can be categorized into three categories:</p>
<ul class="simple">
<li><p>Nodes without Parents within the graph view are the <strong>Input Nodes</strong></p></li>
<li><p>Nodes without Children within the graph view are the <strong>Output Nodes</strong></p></li>
<li><p>Other nodes.</p></li>
</ul>
<p>This distinction enables the definition of forward() and backward() functions for a set of node that defines a graph view.
A node has a reference to each graph view that contains it, this is done in order to update the graph view if the node is modified (merged for example).</p>
<img alt="../../_images/GraphViewExample.PNG" src="../../_images/GraphViewExample.PNG" />
</section>
<section id="operators">
<h2>Operators<a class="headerlink" href="#operators" title="Link to this heading">#</a></h2>
<section id="core-operator">
<h3>Core operator<a class="headerlink" href="#core-operator" title="Link to this heading">#</a></h3>
<p>The Core operators supported are:</p>
<p><strong>Convolution Operators:</strong></p>
<ul class="simple">
<li><p><code class="docutils literal notranslate"><span class="pre">Conv1D</span></code>: Applies a 1D convolution over an input data</p></li>
<li><p><code class="docutils literal notranslate"><span class="pre">Conv2D</span></code>: Applies a 2D convolution over an input data</p></li>
<li><p><code class="docutils literal notranslate"><span class="pre">Conv3D</span></code>: Applies a 3D convolution over an input data</p></li>
<li><p><code class="docutils literal notranslate"><span class="pre">ConvNDTranspose</span></code>: Applies a ConvND operator + a transpose operation</p></li>
<li><p><code class="docutils literal notranslate"><span class="pre">ConvDWND</span></code>: Applies a ND depth-wise convolution over an input data</p></li>
</ul>
<p><strong>Pooling Operators:</strong></p>
<ul class="simple">
<li><p><code class="docutils literal notranslate"><span class="pre">MaxPool1D</span></code>: Applies a 1D max pooling over an input data</p></li>
<li><p><code class="docutils literal notranslate"><span class="pre">MaxPool2D</span></code>: Applies a 2D max pooling over an input data</p></li>
<li><p><code class="docutils literal notranslate"><span class="pre">MaxPool3D</span></code>: Applies a 3D max pooling over an input data</p></li>
<li><p><code class="docutils literal notranslate"><span class="pre">AvgPool1D</span></code>: Applies a 1D average pooling over an input data</p></li>
<li><p><code class="docutils literal notranslate"><span class="pre">AvgPool2D</span></code>: Applies a 2D average pooling over an input data</p></li>
<li><p><code class="docutils literal notranslate"><span class="pre">AvgPool3D</span></code>: Applies a 3D average pooling over an input data</p></li>
</ul>
<p><strong>Activation Operators:</strong></p>
<ul class="simple">
<li><p><code class="docutils literal notranslate"><span class="pre">Sigmoid</span></code>: Applies the Sigmoid function over each element of the input data</p></li>
<li><p><code class="docutils literal notranslate"><span class="pre">ReLU</span></code>: Applies the Rectifier Linear Unit function over each element of the input data</p></li>
<li><p><code class="docutils literal notranslate"><span class="pre">ELU</span></code>: Applies the Exponential Linear Unit function over each element of the input data</p></li>
<li><p><code class="docutils literal notranslate"><span class="pre">Hardswitch</span></code>: Applies the Hardswitch function over each element of the input data</p></li>
<li><p><code class="docutils literal notranslate"><span class="pre">GELU</span></code>: Applies the Gated Linear Unit function over each element of the input data</p></li>
<li><p><code class="docutils literal notranslate"><span class="pre">Softplus</span></code>: Applies the Softplus function over each element of the input data</p></li>
<li><p><code class="docutils literal notranslate"><span class="pre">Tanh</span></code>: Applies the Hyperbolic Tangent function over each element of the input data</p></li>
<li><p><code class="docutils literal notranslate"><span class="pre">LeakyReLU</span></code>: Applies the Leaky Rectifier Linear Unit function over each element of the input data</p></li>
</ul>
<p><strong>Normalization Operators:</strong></p>
<ul class="simple">
<li><p><code class="docutils literal notranslate"><span class="pre">BatchNorm1D</span></code>: Applies a BatchNormalization over 2D/3D inputs</p></li>
<li><p><code class="docutils literal notranslate"><span class="pre">BatchNorm2D</span></code>: Applies a BatchNormalization over 4D inputs</p></li>
<li><p><code class="docutils literal notranslate"><span class="pre">BatchNorm3D</span></code>: Applies a BatchNormalization over 5D inputs</p></li>
</ul>
<p><strong>Recurrent Neural Network Operators:</strong></p>
<ul class="simple">
<li><p>RNN: Applies an Elman RNN over an input data</p></li>
<li><p>LSTM: Applies a long short-term memory RNN over an input data</p></li>
<li><p>GRU: Applies a gated recurrent unit RNN over an input data</p></li>
</ul>
<p><strong>Others:</strong></p>
<ul class="simple">
<li><p><code class="docutils literal notranslate"><span class="pre">Fully-connected</span></code>: Applies a transformation of y= Ax + B</p></li>
<li><p><code class="docutils literal notranslate"><span class="pre">MatMul</span></code>: Applies a transformation of y=Ax</p></li>
<li><p><code class="docutils literal notranslate"><span class="pre">Add</span></code>: Applies a transformation of y = x + B (element by element)</p></li>
<li><p><code class="docutils literal notranslate"><span class="pre">Sub</span></code>: Applies a transformation of y = x - B (element by element)</p></li>
<li><p><code class="docutils literal notranslate"><span class="pre">Mul</span></code>: Applies a transformation of y = x * B (element by element)</p></li>
<li><p><code class="docutils literal notranslate"><span class="pre">Div</span></code>: Applies a transformation of y = x / B (element by element)</p></li>
<li><p><code class="docutils literal notranslate"><span class="pre">Pow</span></code>: Applies a transformation of exponentiation (element by element)</p></li>
<li><p><code class="docutils literal notranslate"><span class="pre">Dropout</span></code>: During training, randomly set elements of the inputs to zero</p></li>
<li><p><code class="docutils literal notranslate"><span class="pre">Softmax</span></code>: Applies the Softmax function over an input data</p></li>
<li><p><code class="docutils literal notranslate"><span class="pre">Softmin</span></code>: Applies the Softmin function over an input data</p></li>
<li><p><code class="docutils literal notranslate"><span class="pre">Concat</span></code>: Concatenate several inputs into one output data. Requires common dimensions</p></li>
<li><p><code class="docutils literal notranslate"><span class="pre">Split</span></code>: Split one input into several outputs</p></li>
<li><p><code class="docutils literal notranslate"><span class="pre">Slice</span></code>: Extract a part of the input depending the indications of the user</p></li>
<li><p><code class="docutils literal notranslate"><span class="pre">Transpose</span></code>: Change the input dimensions. Move data elements in the memory.</p></li>
<li><p><code class="docutils literal notranslate"><span class="pre">Reshape</span></code>: Change the inputs dimensions without moving data elements</p></li>
</ul>
</section>
<section id="generic-operator">
<h3>Generic operator<a class="headerlink" href="#generic-operator" title="Link to this heading">#</a></h3>
<p>A <strong>generic operator</strong> is a specific type of <a class="reference internal" href="#operator"><span class="std std-ref">operator</span></a> which can register its attributes at runtime (as opposed to compile time for other operators).
This allows to define at runtime any operator that is neither available in the Core Operators list nor via an available plugin.
Such operator is used to import a DNN model without error when at least one of its operator is unknown.
The user will then be able to modify the resulting <a class="reference internal" href="#introduction"><span class="std std-ref">computational graph</span></a> to replace the operator with a known operator or associate an implementation to the operator.</p>
</section>
<section id="producer">
<h3>Producer<a class="headerlink" href="#producer" title="Link to this heading">#</a></h3>
<p>A <strong>Producer</strong> is a specific type of <a class="reference internal" href="#operator"><span class="std std-ref">operator</span></a> that store a <a class="reference internal" href="data.html#tensor"><span class="std std-ref">Tensor</span></a> in memory and returns it has a Output Tensor. This is used to store parameters or input values.
A Producer has no: input data, parameters or attributes.</p>
<p>The forward function of a producer consists in returning the stored Tensor.</p>
</section>
<section id="transmitter">
<h3>Transmitter<a class="headerlink" href="#transmitter" title="Link to this heading">#</a></h3>
<p>A <strong>Transmitter</strong> is a specific type of <a class="reference internal" href="#operator"><span class="std std-ref">operator</span></a> for memory transfert from one backend/hardware to another.</p>
<img alt="../../_images/Transmitter.PNG" class="align-center" src="../../_images/Transmitter.PNG" />
</section>
<section id="plugin-operator">
<h3>Plugin Operator<a class="headerlink" href="#plugin-operator" title="Link to this heading">#</a></h3>
<p>An operator plugin contains a hardware-agnostic code describing the <a class="reference internal" href="#operator"><span class="std std-ref">operator</span></a>.
This kind of plugin is useful when an unknown operator is detected from an ONNX.
When the ONNX is parsed, the framework will set a <a class="reference internal" href="#generic-operator"><span class="std std-ref">generic operator</span></a> and then replace it with the operator plugin described by the user or developer.</p>
</section>
</section>
<section id="syntax-to-create-a-computational-graph">
<h2>Syntax to create a computational graph<a class="headerlink" href="#syntax-to-create-a-computational-graph" title="Link to this heading">#</a></h2>
<p>Two syntaxes are available to create a <a class="reference internal" href="#introduction"><span class="std std-ref">computational graph</span></a>:</p>
<ul class="simple">
<li><p>The explicit syntax;</p></li>
<li><p>The functional syntax.</p></li>
</ul>
<p>These synthaxes suppose that the <a class="reference internal" href="#node"><span class="std std-ref">node</span></a> objects have already been created and only allow to connect nodes with one another.</p>
<section id="explicit-syntax">
<h3>Explicit syntax<a class="headerlink" href="#explicit-syntax" title="Link to this heading">#</a></h3>
<p>The Explicit Syntax is the main syntax for creating a <a class="reference internal" href="#introduction"><span class="std std-ref">computational graph</span></a>.
After creating <a class="reference internal" href="#node"><span class="std std-ref">nodes</span></a>, connections are managed with the following functionnalies associated to the nodes:</p>
<ul class="simple">
<li><p><code class="docutils literal notranslate"><span class="pre">Add</span> <span class="pre">child</span></code>: connect the output of the node to the input of another node;</p></li>
</ul>
<p>To simplify this synthax, AIDGE proposes the following functions:</p>
<ul class="simple">
<li><p><code class="docutils literal notranslate"><span class="pre">Sequential</span></code>: takes a list of nodes and/or <a class="reference internal" href="#graph-view"><span class="std std-ref">graph view</span></a> as an input and connect them in the order of the list in a sequential fashion, return a graph view of the connected nodes;</p></li>
</ul>
<img alt="../../_images/SeqExample.PNG" class="align-center" src="../../_images/SeqExample.PNG" />
<ul class="simple">
<li><p><code class="docutils literal notranslate"><span class="pre">Parallel</span></code>: takes a list of nodes and/or graph view as an input and connect them in the order of the list in a parallel fashion, return a graph view of the connected nodes.</p></li>
</ul>
<img alt="../../_images/ParallelExample.PNG" class="align-center" src="../../_images/ParallelExample.PNG" />
<p>Here is a more complex example of the Sequential and Parallel keyword:</p>
<img alt="../../_images/SeqParallelExample.PNG" class="align-center" src="../../_images/SeqParallelExample.PNG" />
</section>
<section id="functional-syntax">
<h3>Functional syntax<a class="headerlink" href="#functional-syntax" title="Link to this heading">#</a></h3>
<p>Common deep learning framework such as TensorFlow or PyTorch propose a functionnal syntax.  The functional syntax emulates a call to a function to create the Computational Gaph.
For this, AIDGE introduces a new object, the connector. The connector is passed from <a class="reference internal" href="#node"><span class="std std-ref">node</span></a> to node and connect them.
For example:</p>
<div class="sd-tab-set docutils">
<input checked="checked" id="sd-tab-item-0" name="sd-tab-set-0" type="radio">
<label class="sd-tab-label" for="sd-tab-item-0">
C++</label><div class="sd-tab-content docutils">
<div class="highlight-C++ notranslate"><div class="highlight"><pre><span></span><span class="n">x</span><span class="w"> </span><span class="o">=</span><span class="w"> </span><span class="n">Connector</span><span class="p">();</span>
<span class="n">x</span><span class="w"> </span><span class="o">=</span><span class="w"> </span><span class="n">OperatorA</span><span class="p">()(</span><span class="n">x</span><span class="p">);</span>
<span class="n">x</span><span class="w"> </span><span class="o">=</span><span class="w"> </span><span class="n">OperatorB</span><span class="p">()(</span><span class="n">x</span><span class="p">);</span>
<span class="n">graphViewAB</span><span class="w"> </span><span class="o">=</span><span class="w"> </span><span class="n">x</span><span class="p">.</span><span class="n">getGraph</span><span class="p">();</span>
</pre></div>
</div>
</div>
<input id="sd-tab-item-1" name="sd-tab-set-0" type="radio">
<label class="sd-tab-label" for="sd-tab-item-1">
Python</label><div class="sd-tab-content docutils">
<div class="admonition warning">
<p class="admonition-title">Warning</p>
<p>Not available yet.</p>
</div>
</div>
</div>
<p>This description hides all the verbosity of choosing input/output <a class="reference internal" href="data.html#tensor"><span class="std std-ref">Tensor</span></a>. It is required to provide the right number of input Connectors to each nodes (so an entry of two <a class="reference internal" href="data.html#tensor"><span class="std std-ref">tensors</span></a> will need two connectors).</p>
</section>
</section>
<section id="clone-a-graph">
<h2>Clone a graph<a class="headerlink" href="#clone-a-graph" title="Link to this heading">#</a></h2>
<section id="make-a-deep-copy">
<h3>Make a deep copy<a class="headerlink" href="#make-a-deep-copy" title="Link to this heading">#</a></h3>
<p>Making a deep copy consists of duplicating a graph with all its <a class="reference internal" href="#node"><span class="std std-ref">nodes</span></a>, parameters, attributes and input/output. Modifying the copied graph won’t change the original graph.</p>
<img alt="../../_images/DeepCopy.PNG" class="align-center" src="../../_images/DeepCopy.PNG" />
</section>
<section id="make-a-deep-copy-with-shared-parameters">
<h3>Make a deep copy with shared parameters<a class="headerlink" href="#make-a-deep-copy-with-shared-parameters" title="Link to this heading">#</a></h3>
<p>Making a deep copy with shared parameters consists of duplicating a graph with all its <a class="reference internal" href="#node"><span class="std std-ref">nodes</span></a>, attributes and inputs/outputs. The parameters are shared between the duplicated node and the original one. Changing the parameters of one graph modifies the parameters of the other one.</p>
<img alt="../../_images/DeepCopyShared.PNG" class="align-center" src="../../_images/DeepCopyShared.PNG" />
</section>
</section>
</section>


                </article>
              
              
              
              
              
                <footer class="prev-next-footer d-print-none">
                  
<div class="prev-next-area">
    <a class="left-prev"
       href="data.html"
       title="previous page">
      <i class="fa-solid fa-angle-left"></i>
      <div class="prev-next-info">
        <p class="prev-next-subtitle">previous</p>
        <p class="prev-next-title">Data</p>
      </div>
    </a>
    <a class="right-next"
       href="loadStoreModel.html"
       title="next page">
      <div class="prev-next-info">
        <p class="prev-next-subtitle">next</p>
        <p class="prev-next-title">Load and store model</p>
      </div>
      <i class="fa-solid fa-angle-right"></i>
    </a>
</div>
                </footer>
              
            </div>
            
            
              
                <dialog id="pst-secondary-sidebar-modal"></dialog>
                <div id="pst-secondary-sidebar" class="bd-sidebar-secondary bd-toc"><div class="sidebar-secondary-items sidebar-secondary__inner">


  <div class="sidebar-secondary-item">
<div
    id="pst-page-navigation-heading-2"
    class="page-toc tocsection onthispage">
    <i class="fa-solid fa-list"></i> On this page
  </div>
  <nav class="bd-toc-nav page-toc" aria-labelledby="pst-page-navigation-heading-2">
    <ul class="visible nav section-nav flex-column">
<li class="toc-h2 nav-item toc-entry"><a class="reference internal nav-link" href="#introduction">Introduction</a></li>
<li class="toc-h2 nav-item toc-entry"><a class="reference internal nav-link" href="#node">Node</a></li>
<li class="toc-h2 nav-item toc-entry"><a class="reference internal nav-link" href="#operator">Operator</a><ul class="visible nav section-nav flex-column">
<li class="toc-h3 nav-item toc-entry"><a class="reference internal nav-link" href="#definition">Definition</a></li>
<li class="toc-h3 nav-item toc-entry"><a class="reference internal nav-link" href="#implementation-of-an-operator">Implementation of an operator</a></li>
<li class="toc-h3 nav-item toc-entry"><a class="reference internal nav-link" href="#example-of-operator">Example of Operator</a></li>
</ul>
</li>
<li class="toc-h2 nav-item toc-entry"><a class="reference internal nav-link" href="#graph-view">Graph View</a></li>
<li class="toc-h2 nav-item toc-entry"><a class="reference internal nav-link" href="#operators">Operators</a><ul class="visible nav section-nav flex-column">
<li class="toc-h3 nav-item toc-entry"><a class="reference internal nav-link" href="#core-operator">Core operator</a></li>
<li class="toc-h3 nav-item toc-entry"><a class="reference internal nav-link" href="#generic-operator">Generic operator</a></li>
<li class="toc-h3 nav-item toc-entry"><a class="reference internal nav-link" href="#producer">Producer</a></li>
<li class="toc-h3 nav-item toc-entry"><a class="reference internal nav-link" href="#transmitter">Transmitter</a></li>
<li class="toc-h3 nav-item toc-entry"><a class="reference internal nav-link" href="#plugin-operator">Plugin Operator</a></li>
</ul>
</li>
<li class="toc-h2 nav-item toc-entry"><a class="reference internal nav-link" href="#syntax-to-create-a-computational-graph">Syntax to create a computational graph</a><ul class="visible nav section-nav flex-column">
<li class="toc-h3 nav-item toc-entry"><a class="reference internal nav-link" href="#explicit-syntax">Explicit syntax</a></li>
<li class="toc-h3 nav-item toc-entry"><a class="reference internal nav-link" href="#functional-syntax">Functional syntax</a></li>
</ul>
</li>
<li class="toc-h2 nav-item toc-entry"><a class="reference internal nav-link" href="#clone-a-graph">Clone a graph</a><ul class="visible nav section-nav flex-column">
<li class="toc-h3 nav-item toc-entry"><a class="reference internal nav-link" href="#make-a-deep-copy">Make a deep copy</a></li>
<li class="toc-h3 nav-item toc-entry"><a class="reference internal nav-link" href="#make-a-deep-copy-with-shared-parameters">Make a deep copy with shared parameters</a></li>
</ul>
</li>
</ul>
  </nav></div>

  <div class="sidebar-secondary-item">

  
  <div class="tocsection editthispage">
    <a href="https://gitlab.eclipse.org/eclipse/aidge/aidge/-/edit/master/docs/source/UserGuide/modelGraph.rst">
      <i class="fa-solid fa-pencil"></i>
      
      
        
          Edit on GitLab
        
      
    </a>
  </div>
</div>

  <div class="sidebar-secondary-item">
  <div role="note" aria-label="source link">
    <h3>This Page</h3>
    <ul class="this-page-menu">
      <li><a href="../../_sources/source/UserGuide/modelGraph.rst.txt"
            rel="nofollow">Show Source</a></li>
    </ul>
   </div></div>

</div></div>
              
            
          </div>
          <footer class="bd-footer-content">
            
          </footer>
        
      </main>
    </div>
  </div>
  
  <!-- Scripts loaded after <body> so the DOM is not blocked -->
  <script defer src="../../_static/scripts/bootstrap.js?digest=8878045cc6db502f8baf"></script>
<script defer src="../../_static/scripts/pydata-sphinx-theme.js?digest=8878045cc6db502f8baf"></script>

  <footer class="bd-footer">
<div class="bd-footer__inner bd-page-width">
  
    <div class="footer-items__start">
      
        <div class="footer-item">

  <p class="copyright">
    
      © Copyright 2023, CEA LIST.
      <br/>
    
  </p>
</div>
      
        <div class="footer-item">

  <p class="sphinx-version">
    Created using <a href="https://www.sphinx-doc.org/">Sphinx</a> 8.1.3.
    <br/>
  </p>
</div>
      
    </div>
  
  
  
    <div class="footer-items__end">
      
        <div class="footer-item">
<p class="theme-version">
  <!-- # L10n: Setting the PST URL as an argument as this does not need to be localized -->
  Built with the <a href="https://pydata-sphinx-theme.readthedocs.io/en/stable/index.html">PyData Sphinx Theme</a> 0.16.1.
</p></div>
      
    </div>
  
</div>

  </footer>
  </body>
</html>